Traceback in error log during heat-engine service shutdown

Bug #1562042 reported by Ivan Udovichenko on 2016-03-25
16
This bug affects 2 people
Affects Status Importance Assigned to Milestone
OpenStack Heat
Fix Released
Medium
Oleksii Chuprykov
Ubuntu Cloud Archive
Medium
Unassigned
Liberty
Medium
James Page
Mitaka
Medium
James Page
heat (Ubuntu)
Medium
James Page
Wily
Medium
James Page
Xenial
Medium
James Page
Yakkety
Medium
James Page

Bug Description

During shutdown of heat-engine service this traceback could be observed in log:
```
2016-03-25 17:29:22.259 22588 DEBUG oslo_service.service [-] Stop services. stop /usr/lib/python2.7/dist-packages/oslo_service/service.py:583
2016-03-25 17:29:22.261 22588 DEBUG heat.engine.service [-] Attempting to stop engine service... _stop_rpc_server /usr/lib/python2.7/dist-packages/heat/engine/service.py:410
2016-03-25 17:29:22.262 22588 ERROR heat.engine.service [-] Failed to stop engine service, 'NoneType' object has no attribute 'stop'
2016-03-25 17:29:22.264 22588 CRITICAL heat-engine [-] AttributeError: 'NoneType' object has no attribute 'groups'
2016-03-25 17:29:22.264 22588 ERROR heat-engine Traceback (most recent call last):
2016-03-25 17:29:22.264 22588 ERROR heat-engine File "/usr/bin/heat-engine", line 10, in <module>
2016-03-25 17:29:22.264 22588 ERROR heat-engine sys.exit(main())
2016-03-25 17:29:22.264 22588 ERROR heat-engine File "/usr/lib/python2.7/dist-packages/heat/cmd/engine.py", line 79, in main
2016-03-25 17:29:22.264 22588 ERROR heat-engine launcher.wait()
2016-03-25 17:29:22.264 22588 ERROR heat-engine File "/usr/lib/python2.7/dist-packages/oslo_service/service.py", line 577, in wait
2016-03-25 17:29:22.264 22588 ERROR heat-engine self.stop()
2016-03-25 17:29:22.264 22588 ERROR heat-engine File "/usr/lib/python2.7/dist-packages/oslo_service/service.py", line 586, in stop
2016-03-25 17:29:22.264 22588 ERROR heat-engine service.stop()
2016-03-25 17:29:22.264 22588 ERROR heat-engine File "/usr/lib/python2.7/dist-packages/osprofiler/profiler.py", line 117, in wrapper
2016-03-25 17:29:22.264 22588 ERROR heat-engine return f(*args, **kwargs)
2016-03-25 17:29:22.264 22588 ERROR heat-engine File "/usr/lib/python2.7/dist-packages/heat/engine/service.py", line 426, in stop
2016-03-25 17:29:22.264 22588 ERROR heat-engine for stack_id in list(self.thread_group_mgr.groups.keys()):
2016-03-25 17:29:22.264 22588 ERROR heat-engine AttributeError: 'NoneType' object has no attribute 'groups'
2016-03-25 17:29:22.264 22588 ERROR heat-engine
2016-03-25 17:29:22.388 22599 INFO oslo_service.service [-] Parent process has died unexpectedly, exiting
```

Full log could be found here:
http://pastebin.com/raw/mgRbgvjd

Changed in heat:
assignee: nobody → Oleksii Chuprykov (ochuprykov)

Fix proposed to branch: master
Review: https://review.openstack.org/297756

Changed in heat:
status: New → In Progress

Reviewed: https://review.openstack.org/297756
Committed: https://git.openstack.org/cgit/openstack/heat/commit/?id=151e8b8e62a508f07e4a67bee2418e4965c59944
Submitter: Jenkins
Branch: master

commit 151e8b8e62a508f07e4a67bee2418e4965c59944
Author: Oleksii Chuprykov <email address hidden>
Date: Fri Mar 25 18:36:34 2016 +0200

    Stop engine service correctly

    If SIGINT received right after start of heat engine, in the middle
    of start() method, heat engine can not stop correctly. Clean up only
    those resources that actually exist.

    Change-Id: I496f6284e15b4f71b166cc0713cfd41423cce400
    Closes-Bug: #1562042

Changed in heat:
status: In Progress → Fix Released
Changed in heat:
milestone: none → newton-1
importance: Undecided → Medium
Zane Bitter (zaneb) on 2016-04-18
tags: added: liberty-backport-potential mitaka-backport-potential
removed: mitaka
James Page (james-page) on 2016-05-10
Changed in heat (Ubuntu Wily):
status: New → Triaged
Changed in heat (Ubuntu Xenial):
status: New → Triaged
Changed in heat (Ubuntu Yakkety):
status: New → Triaged
Changed in heat (Ubuntu Wily):
importance: Undecided → Medium
Changed in heat (Ubuntu Yakkety):
importance: Undecided → Medium
Changed in heat (Ubuntu Xenial):
importance: Undecided → Medium
James Page (james-page) on 2016-05-10
Changed in heat (Ubuntu Yakkety):
status: Triaged → In Progress
assignee: nobody → James Page (james-page)
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package heat - 1:6.0.0-0ubuntu2

---------------
heat (1:6.0.0-0ubuntu2) yakkety; urgency=medium

  * d/p/engine-shutdown.patch: Cherry pick fix to ensure that heat-engine
    worker processes are shutdown correctly when SIGINT is received early
    in the process lifecycle (LP: #1562042).

 -- James Page <email address hidden> Tue, 10 May 2016 13:19:52 +0100

Changed in heat (Ubuntu Yakkety):
status: In Progress → Fix Released
tags: added: sts-needs-review
James Page (james-page) on 2016-05-16
Changed in cloud-archive:
status: Triaged → Fix Committed
James Page (james-page) wrote :
Download full text (16.9 KiB)

This bug was fixed in the package heat - 1:6.0.0-0ubuntu2~cloud0
---------------

 heat (1:6.0.0-0ubuntu2~cloud0) xenial-newton; urgency=medium
 .
   * New package for the Ubuntu Cloud Archive.
 .
 heat (1:6.0.0-0ubuntu2) yakkety; urgency=medium
 .
   * d/p/engine-shutdown.patch: Cherry pick fix to ensure that heat-engine
     worker processes are shutdown correctly when SIGINT is received early
     in the process lifecycle (LP: #1562042).
 .
 heat (1:6.0.0-0ubuntu1) xenial; urgency=medium
 .
   * New upstream release for OpenStack Mitaka.
 .
 heat (1:6.0.0~rc1-0ubuntu1) xenial; urgency=medium
 .
   * New upstream release candidate for OpenStack Mitaka.
   * d/control: Align (build-)depends with upstream.
 .
 heat (1:6.0.0~b3-0ubuntu1) xenial; urgency=medium
 .
   * New upstream milestone for OpenStack Mitaka.
   * d/p/use-oslo-config-fixture-for-tests.patch: Removed. Fixed upstream.
   * d/control: Align (build-)depends with upstream.
 .
 heat (1:6.0.0~b2-0ubuntu2) xenial; urgency=medium
 .
   * d/p/use-oslo-config-fixture-for-tests.patch: Cherry-picked from upstream
     master branch to fix test failures with new oslo.config versions.
 .
 heat (1:6.0.0~b2-0ubuntu1) xenial; urgency=medium
 .
   * New upstream milestone for OpenStack Mitaka.
   * d/control: Align (build-)depends with upstream.
 .
 heat (1:6.0.0~b1-0ubuntu1) xenial; urgency=medium
 .
   * New upstream milestone for OpenStack Mitaka.
   * d/control: Align (build-)depends with upstream.
   * d/p/fixup-assert-regex.patch: Rebased.
 .
 heat (1:5.0.0-0ubuntu1) wily; urgency=medium
 .
   * New upstream release for OpenStack Liberty.
 .
 heat (1:5.0.0~rc2-0ubuntu1) wily; urgency=medium
 .
   * New upstream release candidate for OpenStack Liberty.
   * Don't clean heat.egg-info ensuring that non-py resources actually
     get installed (LP: #1505444).
 .
 heat (1:5.0.0~rc1-0ubuntu1) wily; urgency=medium
 .
   * New upstream release candidate for OpenStack Liberty.
   * d/control: Align (build-)depends with upstream.
   * d/watch: Update to cope with upstream rc versioning.
   * d/rules: Drop removal of .eggs directory in override_dh_auto_clean.
   * d/control: Bump minimum pbr version to 1.8.
 .
 heat (1:5.0.0~b3-0ubuntu1) wily; urgency=medium
 .
   * New upstream milestone for OpenStack Liberty.
   * d/control: Align (build-)depends with upstream.
   * d/p/fix-dummy-resource-missing.patch: Dropped. Fixed in milestone.
   * d/p/move-extensions.patch: Dropped. Fixed in milestone.
 .
 heat (1:5.0.0~b2-0ubuntu2) wily; urgency=medium
 .
   * d/control: Add python-pymysql to (build-)depends.
   * d/p/fix-dummy-resource-missing.patch: Cherry-picked from master to fix
     failing tests.
   * d/p/move-extensions: Cherry-picked from master to fix failing tests.
 .
 heat (1:5.0.0~b2-0ubuntu1) wily; urgency=medium
 .
   * New upstream milestone for OpenStack Liberty.
   * d/control: Align (build-)depends with upstream.
   * d/p/fix-requirements.patch: Dropped. No longer needed.
   * d/p/fixup-assert-regex.patch: Rebased.
   * d/rules: Remove .eggs directory in override_dh_auto_clean.
 .
 heat (1:5.0.0~b1-0ubuntu4) wily; urgency=medium
 .
   * d/heat-common.install: Include missing templates ...

Changed in cloud-archive:
status: Fix Committed → Fix Released
James Page (james-page) wrote :

Ubuntu SRU information

[Impact]
OpenStack heat installations may end up with a load of non-functional heat-engine processes as the controller process fails to terminate them correctly on shutdown.

[Test Case]
sudo apt-get install heat-engine
sudo service heat-engine restart
<not all heat-engine processes will be terminated>

[Regression Potential]
Minimal; in newton and backports in process to other stable branches.

Changed in heat (Ubuntu Xenial):
assignee: nobody → James Page (james-page)
status: Triaged → In Progress
Changed in cloud-archive:
status: Triaged → Fix Released
Changed in heat (Ubuntu Wily):
assignee: nobody → James Page (james-page)
status: Triaged → In Progress

Reviewed: https://review.openstack.org/308783
Committed: https://git.openstack.org/cgit/openstack/heat/commit/?id=1826359ab0064614c41248ca30b47de3ec07c48f
Submitter: Jenkins
Branch: stable/mitaka

commit 1826359ab0064614c41248ca30b47de3ec07c48f
Author: Oleksii Chuprykov <email address hidden>
Date: Fri Mar 25 18:36:34 2016 +0200

    Stop engine service correctly

    If SIGINT received right after start of heat engine, in the middle
    of start() method, heat engine can not stop correctly. Clean up only
    those resources that actually exist.

    Change-Id: I496f6284e15b4f71b166cc0713cfd41423cce400
    Closes-Bug: #1562042
    (cherry picked from commit 151e8b8e62a508f07e4a67bee2418e4965c59944)

Reviewed: https://review.openstack.org/317361
Committed: https://git.openstack.org/cgit/openstack/heat/commit/?id=93c5a3a68a0c0da6c703f72940db7516fb34d619
Submitter: Jenkins
Branch: stable/liberty

commit 93c5a3a68a0c0da6c703f72940db7516fb34d619
Author: Oleksii Chuprykov <email address hidden>
Date: Fri Mar 25 18:36:34 2016 +0200

    Stop engine service correctly

    If SIGINT received right after start of heat engine, in the middle
    of start() method, heat engine can not stop correctly. Clean up only
    those resources that actually exist.

    Change-Id: I496f6284e15b4f71b166cc0713cfd41423cce400
    Closes-Bug: #1562042
    (cherry picked from commit 151e8b8e62a508f07e4a67bee2418e4965c59944)

Hello Ivan, or anyone else affected,

Accepted heat into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/heat/1:6.0.0-0ubuntu1.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in heat (Ubuntu Xenial):
status: In Progress → Fix Committed
tags: added: verification-needed
Martin Pitt (pitti) wrote :

Hello Ivan, or anyone else affected,

Accepted heat into wily-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/heat/1:5.0.1-0ubuntu3.1 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in heat (Ubuntu Wily):
status: In Progress → Fix Committed
James Page (james-page) wrote :

Hello Ivan, or anyone else affected,

Accepted heat into mitaka-proposed. The package will build now and be available in the Ubuntu Cloud Archive in a few hours, and then in the -proposed repository.

Please help us by testing this new package. To enable the -proposed repository:

  sudo add-apt-repository cloud-archive:mitaka-proposed
  sudo apt-get update

Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-mitaka-needed to verification-mitaka-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-mitaka-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-mitaka-needed
James Page (james-page) wrote :

Hello Ivan, or anyone else affected,

Accepted heat into liberty-proposed. The package will build now and be available in the Ubuntu Cloud Archive in a few hours, and then in the -proposed repository.

Please help us by testing this new package. To enable the -proposed repository:

  sudo add-apt-repository cloud-archive:liberty-proposed
  sudo apt-get update

Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-liberty-needed to verification-liberty-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-liberty-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

tags: added: verification-liberty-needed

This issue was fixed in the openstack/heat 7.0.0.0b1 development milestone.

James Page (james-page) on 2016-06-23
tags: added: verification-done verification-mitaka-done
removed: verification-mitaka-needed verification-needed
James Page (james-page) wrote :

Verified fixed across UCA liberty/mitaka and Ubuntu Wily/Xenial (regression test only as systemd does a better job on tidying processes than upstart does)

tags: added: verification-liberty-done
removed: verification-liberty-needed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package heat - 1:5.0.1-0ubuntu3.1

---------------
heat (1:5.0.1-0ubuntu3.1) wily; urgency=medium

  * d/p/engine-shutdown.patch: Cherry pick fix to ensure that heat-engine
    worker processes are shutdown correctly when SIGINT is received early
    in the process lifecycle (LP: #1562042).

 -- James Page <email address hidden> Tue, 10 May 2016 12:40:54 +0100

Changed in heat (Ubuntu Wily):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for heat has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package heat - 1:6.0.0-0ubuntu1.1

---------------
heat (1:6.0.0-0ubuntu1.1) xenial; urgency=medium

  * d/p/engine-shutdown.patch: Cherry pick fix to ensure that heat-engine
    worker processes are shutdown correctly when SIGINT is received early
    in the process lifecycle (LP: #1562042).

 -- James Page <email address hidden> Tue, 10 May 2016 12:40:54 +0100

Changed in heat (Ubuntu Xenial):
status: Fix Committed → Fix Released
James Page (james-page) wrote :

The verification of the Stable Release Update for heat has completed successfully and the package has now been released to -updates. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

James Page (james-page) wrote :

This bug was fixed in the package heat - 1:5.0.1-0ubuntu3.1~cloud0
---------------

 heat (1:5.0.1-0ubuntu3.1~cloud0) trusty-liberty; urgency=medium
 .
   * New update for the Ubuntu Cloud Archive.
 .
 heat (1:5.0.1-0ubuntu3.1) wily; urgency=medium
 .
   * d/p/engine-shutdown.patch: Cherry pick fix to ensure that heat-engine
     worker processes are shutdown correctly when SIGINT is received early
     in the process lifecycle (LP: #1562042).

James Page (james-page) wrote :

The verification of the Stable Release Update for heat has completed successfully and the package has now been released to -updates. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

James Page (james-page) wrote :

This bug was fixed in the package heat - 1:6.0.0-0ubuntu1.1~cloud0
---------------

 heat (1:6.0.0-0ubuntu1.1~cloud0) trusty-mitaka; urgency=medium
 .
   * New update for the Ubuntu Cloud Archive.
 .
 heat (1:6.0.0-0ubuntu1.1) xenial; urgency=medium
 .
   * d/p/engine-shutdown.patch: Cherry pick fix to ensure that heat-engine
     worker processes are shutdown correctly when SIGINT is received early
     in the process lifecycle (LP: #1562042).

This issue was fixed in the openstack/heat 6.1.0 release.

This issue was fixed in the openstack/heat 5.0.2 release.

This issue was fixed in the openstack/heat 6.1.0 release.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers